                     // Persistence of Vision Ray Tracer Include File
// File: escherish.inc
// Vers: 3.6
// Desc: Impossible Figure Like Escher Triangle
// Date: 12/xx/07
// Auth: Stephen R. Hall
//
// ----------------------------------------

#macro Init_Arrays(s)
        #declare pigments = array[s]
        #declare textures = array[s]
        #declare givens = array[4 * s][2]
        #declare figureds = array[2 * s][2]
#end

#macro Create_Figure(w,r,s,th)
        #declare figure=
        union
        {
        #ifndef (outline_tex)
                #declare outline_tex=texture{pigment{color rgb <1,1,1>} finish{diffuse .8}}
        #end
        
        #ifdef (seedish)
                #declare seeder = seed(seedish);
                #declare Loop_One = 0;
                #while ( Loop_One < s)
                        #declare pigments[Loop_One] = pigment{color rgb<rand(seeder),rand(seeder),rand(seeder)>};
                        #declare textures[Loop_One] = texture{pigment{pigments[Loop_One]} finish {ambient 1}}
                        #declare Loop_One = Loop_One + 1;
                #end
        #end
        
        #ifndef (ht)
                #declare ht=.1;
        #end

        #declare Loop_One = 0;
        #while ( Loop_One < 4 )
                #declare givens[Loop_One][0] = ((Loop_One - 1.5) * w);
                #declare givens[Loop_One][1] = -1 * r;
                #if ((Loop_One=1)|(Loop_One=2))
                        #ifndef (flat_border)
                                sphere
                                {
                                        <givens[Loop_One][0],givens[Loop_One][1],0>,
                                        th
                                        texture{outline_tex}
                                }
                        #else
                                cylinder
                                {
                                        <givens[Loop_One][0],givens[Loop_One][1],-1*ht/2>,
                                        <givens[Loop_One][0],givens[Loop_One][1],ht/2>,
                                        th
                                        texture{outline_tex}
                                }
                        #end
                #end
                #declare Loop_One = Loop_One + 1;
        #end

        #declare rot_angle = (2 * pi) / s;
        #declare Loop_One = 1;
        #while ( Loop_One < s )
                #declare Loop_Two = 0;
                #while ( Loop_Two < 4 )
                        #declare givens[(Loop_One * 4)+Loop_Two][0] = 
                                givens[Loop_Two][0]*cos(rot_angle*Loop_One)+-1*givens[Loop_Two][1]*sin(rot_angle*Loop_One);
                        #declare givens[(Loop_One * 4)+Loop_Two][1] =
                                givens[Loop_Two][0]*sin(rot_angle*Loop_One)+givens[Loop_Two][1]*cos(rot_angle*Loop_One);
                        #if ((Loop_Two=1)|(Loop_Two=2))
                                #ifndef (flat_border)
                                        sphere
                                        {
                                                <givens[(Loop_One * 4)+Loop_Two][0],givens[(Loop_One * 4)+Loop_Two][1],0>,
                                                th 
                                                texture{outline_tex}
                                        }
                                #else
                                        cylinder
                                        {
                                                <givens[(Loop_One * 4)+Loop_Two][0],givens[(Loop_One * 4)+Loop_Two][1],-1*ht/2>,
                                                <givens[(Loop_One * 4)+Loop_Two][0],givens[(Loop_One * 4)+Loop_Two][1],ht/2>,
                                                th 
                                                texture{outline_tex}
                                        }
                                #end        
                        #end        
                        #declare Loop_Two = Loop_Two + 1;
                #end
                #declare Loop_One = Loop_One + 1;
        #end
        
        #declare Loop_One = 0;
        #while ( Loop_One < (s-1) )
                #ifndef (flat_border)
                        cylinder
                        {
                                <givens[(Loop_One * 4)+2][0],givens[(Loop_One * 4)+2][1],0>,
                                <givens[(Loop_One * 4)+5][0],givens[(Loop_One * 4)+5][1],0>,
                                th
                                texture{outline_tex}
                        }
                #else
                        #declare xx = givens[(Loop_One * 4)+5][0]-givens[(Loop_One * 4)+2][0];
                        #declare yy = givens[(Loop_One * 4)+5][1]-givens[(Loop_One * 4)+2][1];
                        #declare theta = atan2(yy,xx)*180/pi;
                        #declare length = sqrt((xx*xx)+(yy*yy));
                        box
                        {
                                <0,th,ht/2>,
                                <length,-1*th,-1*ht/2>
                                texture{outline_tex}
                                rotate<0,0,theta>
                                translate<givens[(Loop_One * 4)+2][0],givens[(Loop_One * 4)+2][1],0>
                        }
                #end
                #ifndef (flat_border)
                        cylinder
                        {
                                <givens[(Loop_One * 4)+1][0],givens[(Loop_One * 4)+1][1],0>,
                                <givens[(Loop_One * 4)+2][0],givens[(Loop_One * 4)+2][1],0>,
                                th
                                texture{outline_tex}
                        }
                #else
                        #declare xx = givens[(Loop_One * 4)+2][0]-givens[(Loop_One * 4)+1][0];
                        #declare yy = givens[(Loop_One * 4)+2][1]-givens[(Loop_One * 4)+1][1];
                        #declare theta = atan2(yy,xx)*180/pi;
                        #declare length = sqrt((xx*xx)+(yy*yy));
                        box
                        {
                                <0,th,ht/2>,
                                <length,-1*th,-1*ht/2>
                                texture{outline_tex}
                                rotate<0,0,theta>
                                translate<givens[(Loop_One * 4)+1][0],givens[(Loop_One * 4)+1][1],0>
                        }
                #end                
                #declare Loop_One = Loop_One + 1;
        #end
        #ifndef (flat_border)
                cylinder
                {
                        <givens[(s * 4) - 2][0],givens[(s * 4) - 2][1],0>,
                        <givens[1][0],givens[1][1],0>,
                        th
                        texture{outline_tex}
                }
        #else
                #declare xx = givens[(s * 4) - 2][0]-givens[1][0];
                #declare yy = givens[(s * 4) - 2][1]-givens[1][1];
                #declare theta = atan2(yy,xx)*180/pi;
                #declare length = sqrt((xx*xx)+(yy*yy));
                box
                {
                        <0,th,ht/2>,
                        <length,-1*th,-1*ht/2>
                        texture{outline_tex}
                        rotate<0,0,theta>
                        translate<givens[1][0],givens[1][1],0>
                }
        #end
        #ifndef (flat_border)
        cylinder
        {
                <givens[(s * 4) - 3][0],givens[(s * 4) - 3][1],0>,
                <givens[(s * 4) - 2][0],givens[(s * 4) - 2][1],0>,
                th
                texture{outline_tex}
        }
        #else
                #declare xx = givens[(s * 4) - 3][0]-givens[(s * 4) - 2][0];
                #declare yy = givens[(s * 4) - 3][1]-givens[(s * 4) - 2][1];
                #declare theta = atan2(yy,xx)*180/pi;
                #declare length = sqrt((xx*xx)+(yy*yy));
                box
                {
                        <0,th,ht/2>,
                        <length,-1*th,-1*ht/2>
                        texture{outline_tex}
                        rotate<0,0,theta>
                        translate<givens[(s * 4) - 2][0],givens[(s * 4) - 2][1],0>
                }
        #end

        #declare Loop_One=0;
        #while ( Loop_One < s )
                #declare a = (Loop_One * 4)+1;
                #declare x1 = givens[a][0];
                #declare y1 = givens[a][1];
                #declare a = (Loop_One * 4)+6;
                #if ( a >= (s*4))
                        #declare a = a - (s*4);
                #end
                #declare x2 = givens[a][0];
                #declare y2 = givens[a][1];
                #declare a = (Loop_One * 4)+11;
                #if ( a >= (s*4))
                        #declare a = a - (s*4);
                #end
                #declare x3 = givens[a][0];
                #declare y3 = givens[a][1];
                #declare a = (Loop_One * 4)+4;
                #if ( a >= (s*4))
                        #declare a = a - (s*4);
                #end
                #declare x4 = givens[a][0];
                #declare y4 = givens[a][1];
                #declare x5 = givens[Loop_One * 4][0];
                #declare y5 = givens[Loop_One * 4][1];
                #declare a = (Loop_One * 4)+7;
                #if ( a >= (s*4) )
                        #declare a = a - (s*4);
                #end
                #declare x6 = givens[a][0];
                #declare y6 = givens[a][1];
                #if (x1=x2)
                        #declare x2 = x2 + .00001;
                #end
                #if (x3=x4)
                        #declare x4 = x4 + .00001;
                #end
                #if (x5=x6)
                        #declare x6 = x6 + .00001;
                #end                                
                #declare m11 = (y2-y1)/(x2-x1);
                #declare m21 = (y4-y3)/(x4-x3);
                #declare m12 = (y6-y5)/(x6-x5);
                #declare m22 = (y4-y3)/(x4-x3);
                #declare figureds[Loop_One * 2][0] = (y3-y1+(m11*x1)-(m21*x3))/(m11-m21);
                #declare figureds[Loop_One * 2][1] = m11*(figureds[Loop_One * 2][0]-x1)+y1;
                #declare figureds[Loop_One * 2+1][0] = (y3-y5+(m12*x5)-(m22*x3))/(m12-m22);
                #declare figureds[Loop_One * 2+1][1] = m12*(figureds[Loop_One * 2+1][0]-x5)+y5;
                #ifndef(flat_border)
                        sphere
                        {
                                <figureds[Loop_One * 2][0],figureds[Loop_One * 2][1],0>,
                                th 
                                texture{outline_tex}
                        }
                        sphere
                        {
                                <figureds[Loop_One * 2+1][0],figureds[Loop_One * 2+1][1],0>,
                                th 
                                texture{outline_tex}
                        }
                #else
                        cylinder
                        {
                                <figureds[Loop_One * 2][0],figureds[Loop_One * 2][1],-1*ht/2>,
                                <figureds[Loop_One * 2][0],figureds[Loop_One * 2][1],ht/2>,
                                th 
                                texture{outline_tex}
                        }
                        cylinder
                        {
                                <figureds[Loop_One * 2+1][0],figureds[Loop_One * 2+1][1],-1*ht/2>,
                                <figureds[Loop_One * 2+1][0],figureds[Loop_One * 2+1][1],ht/2>,
                                th 
                                texture{outline_tex}
                        }       
                #end
                #declare Loop_One = Loop_One + 1;
        #end

        #declare Loop_One = 0;
        #while ( Loop_One < s )
                #ifndef (flat_border)
                        cylinder
                        {
                                <givens[(Loop_One * 4)+1][0],givens[(Loop_One * 4)+1][1],0>,
                                <figureds[Loop_One * 2][0],figureds[Loop_One * 2][1],0>,
                                th
                                texture{outline_tex}
                        }
                #else
                        #declare xx = givens[(Loop_One * 4)+1][0]-figureds[Loop_One * 2][0];
                        #declare yy = givens[(Loop_One * 4)+1][1]-figureds[Loop_One * 2][1];
                        #declare theta = atan2(yy,xx)*180/pi;
                        #declare length = sqrt((xx*xx)+(yy*yy));
                        box
                        {
                                <0,th,ht/2>,
                                <length,-1*th,-1*ht/2>
                                texture{outline_tex}
                                rotate<0,0,theta>
                                translate<figureds[Loop_One * 2][0],figureds[Loop_One * 2][1],0>
                        }                
                #end
                #declare a = (Loop_One * 2) + 3;
                #if ( a >= (s*2))
                        #declare a = a - (s*2);
                #end
                #ifndef (flat_border)
                        cylinder
                        {
                                <figureds[Loop_One * 2][0],figureds[Loop_One * 2][1],0>,
                                <figureds[a][0],figureds[a][1],0>,
                                th
                                texture{outline_tex}
                        }
                #else
                        #declare xx = figureds[Loop_One * 2][0]-figureds[a][0];
                        #declare yy = figureds[Loop_One * 2][1]-figureds[a][1];
                        #declare theta = atan2(yy,xx)*180/pi;
                        #declare length = sqrt((xx*xx)+(yy*yy));
                        box
                        {
                                <0,th,ht/2>,
                                <length,-1*th,-1*ht/2>
                                texture{outline_tex}
                                rotate<0,0,theta>
                                translate<figureds[a][0],figureds[a][1],0>
                        }
                #end                
                #declare Loop_One = Loop_One + 1;
        #end

        #declare Loop_One = 0;
        #while ( Loop_One < s )
                #declare a = (Loop_One * 4) + 1;
                #declare b = (Loop_One * 4) + 2;
                #declare c = (Loop_One * 4) + 5;
                #if ( c >= (s*4) )
                        #declare c = c - (s*4);
                #end
                #declare d = (Loop_One * 2) + 2;
                #if ( d >= (s*2) )
                        #declare d = d - (s*2);
                #end
                #declare e = (Loop_One * 2) + 3;
                #if ( e >= (s*2) )
                        #declare e = e - (s*2);
                #end
                #declare f = Loop_One * 2;
                polygon
                {
                        6,
                        <givens[a][0],givens[a][1]>,
                        <givens[b][0],givens[b][1]>,
                        <givens[c][0],givens[c][1]>,
                        <figureds[d][0],figureds[d][1]>,
                        <figureds[e][0],figureds[e][1]>,
                        <figureds[f][0],figureds[f][1]>
                        texture{textures[Loop_One]}
                }

                #declare Loop_One = Loop_One + 1;
        #end
        }
#end